#!/usr/bin/python3

import pylab as plb
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit
from scipy import asarray as ar,exp
import math

import sys


fname = sys.argv[1]
outfname = sys.argv[2]
outdata = sys.argv[3]


xx = []
yy = []

f = open(fname)
for l in f:
  l = l.strip()
  if len(l) == 0: continue
  ll = l.split('\t')
  mxx = float(ll[1])
  #
  if mxx >= 3.0:
    xx.append( float(ll[1]) )
    yy.append( float(ll[2]) )
  ############################################
  ### Note_1 **********************************
  # if mxx >= 3.9:
  #   xx.append( float(ll[1]) )
  #   yy.append( float(ll[2]) )
  ############################################


n = len(xx)




############################################
# Note_2 ****************************
# y_max = 0.0
# for i in range(n):
#   if yy[i] >= y_max:  y_max = yy[i]
#
# for i in range(n):
#   yy[i] /= y_max
#   yy[i] *= 0.5
############################################


x = ar(xx)
y = ar(yy)



mean = sum(x*y)/n                   #note this correction
sigma = sum(y*(x-mean)**2)/n        #note this correction

############################################
# Note_3 ****************************
mean = 9.5
sigma = 1.0
############################################


print("> n:      ", n)
print("> mean:   ", mean)
print("> sigma:  ", sigma)

fout = open(outdata, 'w')
fout.write('\n')
line  = 'n:     '+str(n)+'\n'
line += 'mean:  {0:0.4f}\n'.format(mean)
line += 'sigma: {0:0.4f}\n'.format(sigma)
fout.write(line)
fout.write('\n')



def gaus(x,a,x0,sigma):
    return a*exp(-(x-x0)**2/(2*sigma**2))

# popt,pcov = curve_fit(gaus,x,y,p0=[1,mean,sigma])
popt,pcov = curve_fit(gaus,x,y,p0=[1,mean,sigma])


#######################################################
# Plotting.

# im_w = 400
# im_h = 300
# im_dpi = 80
# plt.figure( figsize=(im_w/im_dpi, im_h/im_dpi), dpi=im_dpi )


plt.plot(x,y,'g+:',label='data')
plt.plot(x,gaus(x,*popt),'ro:',label='fit', markersize=3)
plt.legend()
plt.xlabel('x values')
plt.ylabel('y values')

# plt.show()
# plt.savefig(outfname, bbox_inches='tight', dpi=im_dpi)
# # Using bbox_inches='tight' results in a figure that is no longer 400x300.
# plt.savefig(outfname, dpi=im_dpi)

plt.savefig(outfname, bbox_inches='tight')



